<template>
  <div>
    <!--引用表格-->
   <BasicTable @register="registerTable" :rowSelection="rowSelection">
     <!--插槽:table标题-->
      <template #tableTitle>
          <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 新增</a-button>
          <a-button  type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
          <j-upload-button  type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
          <a-dropdown v-if="selectedRowKeys.length > 0">
              <template #overlay>
                <a-menu>
                  <a-menu-item key="1" @click="batchHandleDelete">
                    <Icon icon="ant-design:delete-outlined"></Icon>
                    删除
                  </a-menu-item>
                </a-menu>
              </template>
              <a-button>批量操作
                <Icon icon="mdi:chevron-down"></Icon>
              </a-button>
        </a-dropdown>
        <!-- 高级查询 -->
        <super-query :config="superQueryConfig" @search="handleSuperQuery" />
      </template>
     <template #xiaoErUserTag="{ text, record }">
       <!-- 显示每个 text 值 -->
       <a-space :size="[0, 'small']" wrap v-if="text">
         <span v-for="(item, index) in text.split(',')" :key="index">
          <a-tooltip :title="item">
           <a-tag style="margin-right:5px ">{{ item }}</a-tag>
          </a-tooltip>
         </span>
       </a-space>
     </template>
       <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)"/>
      </template>
      <!--字段回显插槽-->
      <template v-slot:bodyCell="{ column, record, index, text }">
      </template>
    </BasicTable>
    <!-- 表单区域 -->
    <OkkiSiteModal @register="registerModal" @success="handleSuccess"></OkkiSiteModal>
    <OkkiXiaoErBindModal @register="registerBindSiteModal" @success="handleSuccess"></OkkiXiaoErBindModal>
  </div>
</template>

<script lang="ts" name="site-okkiSite" setup>
  import {ref, reactive, computed, unref} from 'vue';
  import {BasicTable, useTable, TableAction} from '/@/components/Table';
  import {useModal} from '/@/components/Modal';
  import { useListPage } from '/@/hooks/system/useListPage'
  import OkkiSiteModal from './components/OkkiSiteModal.vue'
  import OkkiXiaoErBindModal from './components/OkkiXiaoErBindModal.vue'
  import {columns, searchFormSchema, superQuerySchema} from './OkkiSite.data';
  import {list, updateStatus, deleteOne, batchDelete, getImportUrl,getExportUrl} from './OkkiSite.api';
  import { downloadFile } from '/@/utils/common/renderUtils';
  import { useUserStore } from '/@/store/modules/user';
  const queryParam = reactive<any>({});
  const checkedKeys = ref<Array<string | number>>([]);
  const userStore = useUserStore();
  //注册model
  const [registerModal, { openModal:openModal }] = useModal();
  const [registerBindSiteModal, { openModal: bindSiteOpenModal }] = useModal();

  // const registerBindSiteModal = ref();

  //注册table数据
  const { prefixCls,tableContext,onExportXls,onImportXls } = useListPage({
      tableProps:{
           title: '站点',
           api: list,
           columns,
           canResize:false,
           formConfig: {
              //labelWidth: 120,
              schemas: searchFormSchema,
              autoSubmitOnEnter:true,
              showAdvancedButton:true,
              fieldMapToNumber: [
              ],
              fieldMapToTime: [
              ],
            },
           actionColumn: {
               width: 220,
               fixed:'right'
            },
            beforeFetch: (params) => {
              return Object.assign(params, queryParam);
            },
      },
       exportConfig: {
            name:"站点",
            url: getExportUrl,
            params: queryParam,
          },
          importConfig: {
            url: getImportUrl,
            success: handleSuccess
          },
  })

  const [registerTable, {reload},{ rowSelection, selectedRowKeys }] = tableContext

  // 高级查询配置
  const superQueryConfig = reactive(superQuerySchema);

  function getRandomColor() {
    const letters = '0123456789ABCDEF';
    let color = '#';
    for (let i = 0; i < 6; i++) {
      color += letters[Math.floor(Math.random() * 16)];
    }
    return color;
  }

  /**
   * 小二分配
   */
  function handleXiaoErBind(record: Recordable) {
    bindSiteOpenModal(true, {
      record,
      isUpdate: true,
      showFooter: true,
    });
  }

  /**
   * 高级查询事件
   */
  function handleSuperQuery(params) {
    Object.keys(params).map((k) => {
      queryParam[k] = params[k];
    });
    reload();
  }
   /**
    * 新增事件
    */
  function handleAdd() {
     openModal(true, {
       isUpdate: false,
       showFooter: true,
     });
  }
   /**
    * 编辑事件
    */
  function handleEdit(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: true,
     });
   }

   /**
    * 详情
   */
  function handleDetail(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: false,
     });
   }
  /**
   * 修改状态事件
   */
  async function handleUpdateStatus(record) {
    await updateStatus({id: record.id}, handleSuccess);
  }
   /**
    * 删除事件
    */
  async function handleDelete(record) {
     await deleteOne({id: record.id}, handleSuccess);
   }
   /**
    * 批量删除事件
    */
  async function batchHandleDelete() {
     await batchDelete({ids: selectedRowKeys.value}, handleSuccess);
   }
   /**
    * 成功回调
    */
  function handleSuccess() {
      (selectedRowKeys.value = []) && reload();
   }
   /**
      * 操作栏
      */
  function getTableAction(record){
       return [
         // {
         //   label: '授权',
         //   onClick: handleEdit.bind(null, record),
         // },
         {
           label: '小二分配',
           onClick: handleXiaoErBind.bind(null, record),
         }
       ]
   }
     /**
        * 下拉操作栏
        */
  function getDropDownAction(record){
    let statusList = [1,2,3,4,6,7,8,9,11];
    if (statusList.includes(record.status)) {
      let labelText = '';
      switch (record.status) {
        case 1:
          labelText = '服务商启动服务';
          break;
        case 2:
          labelText = '服务需求确定';
          break;
        case 3:
          labelText = '站点样式推荐及确认';
          break;
        case 4:
          labelText = '商家基础资料整理';
          break;
        case 6:
          labelText = '商家产品资料准备';
          break;
        case 7:
          labelText = '网站产品发布';
          break;
        case 8:
          labelText = '网站质检及细节修改';
          break;
        case 9:
          labelText = '装修完成';
          break;
        case 11:
          labelText = 'SEO推广工作开始';
          break;
      }
      return [
        // {
        //   label: '详情',
        //   onClick: handleDetail.bind(null, record),
        // },
        {
          label: labelText,
          popConfirm: {
            title: '是否确认'+labelText,
            confirm: handleUpdateStatus.bind(null, record),
            placement: 'topLeft',
          }
        },
        {
          label: '删除',
          popConfirm: {
            title: '是否确认删除',
            confirm: handleDelete.bind(null, record),
            placement: 'topLeft',
          }
        }
      ]
    } else {
      return [
        {
          label: '详情',
          onClick: handleDetail.bind(null, record),
        }, {
          label: '删除',
          popConfirm: {
            title: '是否确认删除',
            confirm: handleDelete.bind(null, record),
            placement: 'topLeft',
          }
        }
      ]
    }
   }


</script>

<style scoped>

</style>
